#include "actor.h"

namespace Kyra {

	struct ActorAction {
		uint32 id;
		uint32 x, y;
		uint32 count_frames;
	};
	
	enum ActorActions {
		kActorMove = 0,
		kActorSpeak = 1,
		kActorHeadSpeak = 2,
		kActorHeadSpeak2 = 3,
		kActorMoveDown = 4,
		kActorMoveUp = 5,
		kActorActionsEnd
	};
	
	// maybe this points in the actor files are the same but don't know so i did some research to get these values
	const ActorAction actorAction[] = {
		{ kActorMove, 0, 0, 9 }, { kActorSpeak, 216, 0, 1 }, { kActorHeadSpeak, 0, 50, 12 },
		{ kActorHeadSpeak2, 0, 66, 12 }, { kActorMoveDown, 0, 80, 6 }, { kActorMoveUp, 0, 129, 6 },
		{ kActorActionsEnd, 0, 0, 0}
	};
			
	
	void Actor::init(const char* name, CPSImage* sprite,  int32 x, int32 y, int32 color) {
		_name = name;
		_sprite = sprite;
		
		_xpos = x; _ypos = y;
		_color = color;
		
		// we do it hardcoded don't know if there's a other way
		_height = 48; _width = 24;
		_headHeight = 13; _headWidth = 16;
		
		_frame = 0;
		_headFrame = 0;
		
		// we need a good value or the script could set it don't know
		_animationDelay = 100;
	}
	
	void Actor::moveTo(int32 newx, int32 newy) {
		_dstX = newx; _dstY = newy;
	}
	
	void Actor::lookTo(int32 lookx) {
		if (_xpos <= lookx) {
			_direction = kRight;
		} else {
			_direction = kLeft;
		}
	}
	
	void Actor::process(void) {
	}
} // end of namespace Kyra

