#ifndef ACTOR_H
#define ACTOR_H

#include "kyra.h"

namespace Kyra {
	class Actor {
	
	public:
	
		void init(const char* name, CPSImage* sprite,  int32 x, int32 y, int32 color);	
  	
		void moveTo(int32 newx, int32 newy);
		void lookTo(int32 lookx);
		
		const char* named(void) { return _name; }		
		void process(void);
		
		void roomMask(CPSImage* mask) { _roomMask = mask; }
		
		uint32 _animationDelay;	// Zeit bis zur nchsten Animation
	protected:
	
		CPSImage* _roomMask;
	
		const char* _name;
		CPSImage* _sprite;
		int32 _xpos;
		int32 _ypos;
		
		int32 _dstX;
		int32 _dstY;
		
		int32 _height;
		int32 _width;
		int32 _headHeight;
		int32 _headWidth;	
		
		int32 _frame;		// for moving Animations
		int32 _headFrame;	// for talking Animations
		
		int32 _color;		// textcolor
		
		enum Directions {
			kUp = 0,
			kRight = 1,
			kDown = 2,
			kLeft = 3
		};
		
		int32 _direction;	// direction Actor goes/looks to
	
	};
} // end of namespace Kyra

#endif

